open Genlex
open Term

let lexer = make_lexer ["("; ")"; ","; "."; ":-"]

let rec parse_term = parser
  | [< 'Ident s; p = parser 
      | [< 'Kwd "("; args = parse_args; 'Kwd ")" >] -> Fun (s, args)
      | [< >] -> if String.get s 0 < 'a' then Var s else Const s
    >] -> p
and parse_args = parser
  | [< t = parse_term; r = parser
      | [< 'Kwd ","; r = parse_args >] -> r
      | [< >] -> []
    >] -> t :: r
let rec parse_terms = parser
  | [< t = parse_term; r = parser
      | [< 'Kwd ","; r = parse_terms; >] -> r
      | [< >] -> []
    >] -> t :: r
let parse_clause = parser
  | [< h = parse_term; b = parser
      | [< 'Kwd "." >] -> []
      | [< 'Kwd ":-"; b = parse_terms; 'Kwd "." >] -> b
    >] -> (h, b)
let rec parse_clauses = parser
  | [< c = parse_clause; t = parser
      | [< t = parse_clauses >] -> t
      | [< >] -> []
    >] -> c :: t

(* let tokstrm = lexer(Stream.of_channel stdin) *)
let read_clauses() = parse_clauses(lexer(Stream.of_channel stdin))
let read_term() = parse_term(lexer(Stream.of_channel stdin))
